/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.41 Revision 1.362
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.41 2003/07/14 04:47:17 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.362 2011/08/09 00:43:48 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15DEPEND="$DEPEND !bootstrap? ( sys-devel/patch )" 18inherit multilib portability
16 19
17DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
18 21
19# This function generate linker scripts in /usr/lib for dynamic 22if has "${EAPI:-0}" 0 1 2; then
20# libs in /lib. This is to fix linking problems when you have
21# the .so in /lib, and the .a in /usr/lib. What happens is that
22# in some cases when linking dynamic, the .a in /usr/lib is used
23# instead of the .so in /lib due to gcc/libtool tweaking ld's
24# library search path. This cause many builds to fail.
25# See bug #4411 for more info.
26#
27# To use, simply call:
28#
29# gen_usr_ldscript libfoo.so
30#
31# Note that you should in general use the unversioned name of
32# the library, as ldconfig should usually update it correctly
33# to point to the latest version of the library present.
34#
35# <azarah@gentoo.org> (26 Oct 2002)
36#
37gen_usr_ldscript() {
38 23
39 # Just make sure it exists 24# @FUNCTION: epause
40 dodir /usr/lib 25# @USAGE: [seconds]
41 26# @DESCRIPTION:
42 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
43/* GNU ld script 28# printing a message the user should probably be reading and often used in
44 Because Gentoo have critical dynamic libraries 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
45 in /lib, and the static versions in /usr/lib, we 30# don't wait at all. Defined in EAPIs 0 1 and 2.
46 need to have a "fake" dynamic lib in /usr/lib, 31epause() {
47 otherwise we run into linking problems. 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
48 See bug #4411 on http://bugs.gentoo.org/ for
49 more info. */
50GROUP ( /lib/libxxx )
51END_LDSCRIPT
52
53 dosed "s:libxxx:$1:" /usr/lib/$1
54
55 return 0
56} 33}
57 34
58# Simple function to draw a line consisting of '=' the same length as $* 35# @FUNCTION: ebeep
59# 36# @USAGE: [number of beeps]
60# <azarah@gentoo.org> (11 Nov 2002) 37# @DESCRIPTION:
61# 38# Issue the specified number of beeps (default of 5 beeps). Useful when
62draw_line() { 39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
42ebeep() {
63 local i=0 43 local n
64 local str_length="" 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
65 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
66 # Handle calls that do not have args, or wc not being installed ...
67 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
68 then
69 echo "==============================================================="
70 return 0
71 fi
72
73 # Get the length of $*
74 str_length="$(echo -n "$*" | wc -m)"
75
76 while [ "$i" -lt "${str_length}" ]
77 do
78 echo -n "=" 46 echo -ne "\a"
79 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
80 i=$((i + 1)) 48 echo -ne "\a"
49 sleep 1
81 done 50 done
51 fi
52}
82 53
83 echo 54else
84 55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
77# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove CVS directories recursiveley. Useful when a source tarball contains
81# internal CVS directories. Defaults to $PWD.
82ecvs_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
85 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
86}
87
88# @FUNCTION: esvn_clean
89# @USAGE: [list of dirs]
90# @DESCRIPTION:
91# Remove .svn directories recursiveley. Useful when a source tarball contains
92# internal Subversion directories. Defaults to $PWD.
93esvn_clean() {
94 [[ -z $* ]] && set -- .
95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
96}
97
98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
85 return 0 116# return 0
117# fi
118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
86} 134}
87 135
88# Default directory where patches are located 136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
154
155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
89EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
90# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
91EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
92# Default options for patch 165# Default options for patch:
93EPATCH_OPTS="" 166# @CODE
167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
168# --no-backup-if-mismatch - do not leave .orig files behind
169# -E - automatically remove empty files
170# @CODE
171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
95# and not the full path .. 175# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
97# Change the printed message for a single patch. 179# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
99# Force applying bulk patches even if not following the style: 181# @VARIABLE: EPATCH_MULTI_MSG
100# 182# @DESCRIPTION:
101# ??_${ARCH}_foo.${EPATCH_SUFFIX} 183# Change the printed message for multiple patches.
102# 184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
185# @VARIABLE: EPATCH_FORCE
186# @DESCRIPTION:
187# Only require patches to match EPATCH_SUFFIX rather than the extended
188# arch naming style.
103EPATCH_FORCE="no" 189EPATCH_FORCE="no"
104 190
105# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
106# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
107# 199#
108# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
109# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
110# 202#
111# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
112# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
113# 205# if ${EPATCH_FORCE} != "yes"
114# Above EPATCH_* variables can be used to control various defaults,
115# bug they should be left as is to ensure an ebuild can rely on
116# them for.
117#
118# Patches are applied in current directory.
119#
120# Bulk Patches should preferibly have the form of:
121#
122# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
123# 215#
124# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
125# 218#
126# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
127# 02_sparc_another-fix.patch.bz2
128#
129# This ensures that there are a set order, and you can have ARCH
130# specific patches.
131#
132# If you however give an argument to epatch(), it will treat it as a
133# single patch that need to be applied if its a file. If on the other
134# hand its a directory, it will set EPATCH_SOURCE to this.
135#
136# <azarah@gentoo.org> (10 Nov 2002)
137#
138epatch() { 220epatch() {
139 local PIPE_CMD="" 221 _epatch_draw_line() {
140 local STDERR_TARGET="${T}/$$.out" 222 # create a line of same length as input string
141 local PATCH_TARGET="${T}/$$.patch" 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
142 local PATCH_SUFFIX="" 224 echo "${1//?/=}"
225 }
226
227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
228
229 # Let the rest of the code process one user arg at a time --
230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
233 local m
234 for m in "$@" ; do
235 epatch "${m}"
236 done
237 return 0
238 fi
239
143 local SINGLE_PATCH="no" 240 local SINGLE_PATCH="no"
144 local x="" 241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
145 243
146 if [ "$#" -gt 1 ] 244 if [[ -f $1 ]] ; then
147 then
148 eerror "Invalid arguments to epatch()"
149 die "Invalid arguments to epatch()"
150 fi
151
152 if [ -n "$1" -a -f "$1" ]
153 then
154 SINGLE_PATCH="yes" 245 SINGLE_PATCH="yes"
155 246 set -- "$1"
156 local EPATCH_SOURCE="$1" 247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 249 local EPATCH_SUFFIX=$1
158 250
159 elif [ -n "$1" -a -d "$1" ] 251 elif [[ -d $1 ]] ; then
160 then 252 # Some people like to make dirs of patches w/out suffixes (vim)
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 254
255 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
256 # Re-use EPATCH_SOURCE as a search dir
257 epatch "${EPATCH_SOURCE}/$1"
258 return $?
259
260 else
261 # sanity check ... if it isn't a dir or file, wtf man ?
262 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
263 echo
264 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
265 eerror
266 eerror " ${EPATCH_SOURCE}"
267 eerror " ( ${EPATCH_SOURCE##*/} )"
268 echo
269 die "Cannot find \$EPATCH_SOURCE!"
270 fi
271
272 local PIPE_CMD
273 case ${EPATCH_SUFFIX##*\.} in
274 xz) PIPE_CMD="xz -dc" ;;
275 lzma) PIPE_CMD="lzma -dc" ;;
276 bz2) PIPE_CMD="bzip2 -dc" ;;
277 gz|Z|z) PIPE_CMD="gzip -dc" ;;
278 ZIP|zip) PIPE_CMD="unzip -p" ;;
279 *) ;;
280 esac
281
282 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
283
284 local x
285 for x in "$@" ; do
286 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
287 # didn't match anything, ignore continue on
288 [[ ! -f ${x} ]] && continue
289
290 local patchname=${x##*/}
291
292 # Apply single patches, or forced sets of patches, or
293 # patches with ARCH dependant names.
294 # ???_arch_foo.patch
295 # Else, skip this input altogether
296 local a=${patchname#*_} # strip the ???_
297 a=${a%%_*} # strip the _foo.patch
298 if ! [[ ${SINGLE_PATCH} == "yes" || \
299 ${EPATCH_FORCE} == "yes" || \
300 ${a} == all || \
301 ${a} == ${ARCH} ]]
163 then 302 then
164 local EPATCH_SOURCE="$1/*" 303 continue
304 fi
305
306 # Let people filter things dynamically
307 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
308 # let people use globs in the exclude
309 eshopts_push -o noglob
310
311 local ex
312 for ex in ${EPATCH_EXCLUDE} ; do
313 if [[ ${patchname} == ${ex} ]] ; then
314 eshopts_pop
315 continue 2
316 fi
317 done
318
319 eshopts_pop
320 fi
321
322 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
323 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
324 einfo "${EPATCH_SINGLE_MSG}"
325 else
326 einfo "Applying ${patchname} ..."
327 fi
165 else 328 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 329 einfo " ${patchname} ..."
330 fi
331
332 # most of the time, there will only be one run per unique name,
333 # but if there are more, make sure we get unique log filenames
334 local STDERR_TARGET="${T}/${patchname}.out"
335 if [[ -e ${STDERR_TARGET} ]] ; then
336 STDERR_TARGET="${T}/${patchname}-$$.out"
337 fi
338
339 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
340
341 # Decompress the patch if need be
342 local count=0
343 local PATCH_TARGET
344 if [[ -n ${PIPE_CMD} ]] ; then
345 PATCH_TARGET="${T}/$$.patch"
346 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
347
348 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
349 echo
350 eerror "Could not extract patch!"
351 #die "Could not extract patch!"
352 count=5
353 break
167 fi 354 fi
355 else
356 PATCH_TARGET=${x}
357 fi
358
359 # Check for absolute paths in patches. If sandbox is disabled,
360 # people could (accidently) patch files in the root filesystem.
361 # Or trigger other unpleasantries #237667. So disallow -p0 on
362 # such patches.
363 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
364 if [[ -n ${abs_paths} ]] ; then
365 count=1
366 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
367 fi
368 # Similar reason, but with relative paths.
369 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
370 if [[ -n ${rel_paths} ]] ; then
371 eqawarn "QA Notice: Your patch uses relative paths '../'."
372 eqawarn " In the future this will cause a failure."
373 eqawarn "${rel_paths}"
374 fi
375
376 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
377 while [[ ${count} -lt 5 ]] ; do
378 # Generate some useful debug info ...
379 (
380 _epatch_draw_line "***** ${patchname} *****"
381 echo
382 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
383 echo
384 _epatch_draw_line "***** ${patchname} *****"
385 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
386 ret=$?
387 echo
388 echo "patch program exited with status ${ret}"
389 exit ${ret}
390 ) >> "${STDERR_TARGET}"
391
392 if [ $? -eq 0 ] ; then
393 (
394 _epatch_draw_line "***** ${patchname} *****"
395 echo
396 echo "ACTUALLY APPLYING ${patchname} ..."
397 echo
398 _epatch_draw_line "***** ${patchname} *****"
399 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
400 ret=$?
401 echo
402 echo "patch program exited with status ${ret}"
403 exit ${ret}
404 ) >> "${STDERR_TARGET}"
405
406 if [ $? -ne 0 ] ; then
407 echo
408 eerror "A dry-run of patch command succeeded, but actually"
409 eerror "applying the patch failed!"
410 #die "Real world sux compared to the dreamworld!"
411 count=5
412 fi
413 break
414 fi
415
416 : $(( count++ ))
417 done
418
419 # if we had to decompress the patch, delete the temp one
420 if [[ -n ${PIPE_CMD} ]] ; then
421 rm -f "${PATCH_TARGET}"
422 fi
423
424 if [[ ${count} -ge 5 ]] ; then
425 echo
426 eerror "Failed Patch: ${patchname} !"
427 eerror " ( ${PATCH_TARGET} )"
428 eerror
429 eerror "Include in your bugreport the contents of:"
430 eerror
431 eerror " ${STDERR_TARGET}"
432 echo
433 die "Failed Patch: ${patchname}!"
434 fi
435
436 # if everything worked, delete the patch log
437 rm -f "${STDERR_TARGET}"
438 eend 0
439 done
440
441 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
442 : # everything worked
443}
444
445# @FUNCTION: epatch_user
446# @USAGE:
447# @DESCRIPTION:
448# Applies user-provided patches to the source tree. The patches are
449# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
450# of these three directories to exist will be the one to use, ignoring
451# any more general directories which might exist as well.
452#
453# User patches are intended for quick testing of patches without ebuild
454# modifications, as well as for permanent customizations a user might
455# desire. Obviously, there can be no official support for arbitrarily
456# patched ebuilds. So whenever a build log in a bug report mentions that
457# user patches were applied, the user should be asked to reproduce the
458# problem without these.
459#
460# Not all ebuilds do call this function, so placing patches in the
461# stated directory might or might not work, depending on the package and
462# the eclasses it inherits and uses. It is safe to call the function
463# repeatedly, so it is always possible to add a call at the ebuild
464# level. The first call is the time when the patches will be
465# applied.
466#
467# Ideally, this function should be called after gentoo-specific patches
468# have been applied, so that their code can be modified as well, but
469# before calls to e.g. eautoreconf, as the user patches might affect
470# autotool input files as well.
471epatch_user() {
472 [[ $# -ne 0 ]] && die "epatch_user takes no options"
473
474 # Allow multiple calls to this function; ignore all but the first
475 local applied="${T}/epatch_user.applied"
476 [[ -e ${applied} ]] && return 2
477
478 # don't clobber any EPATCH vars that the parent might want
479 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
480 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
481 EPATCH_SOURCE=${base}/${CTARGET}/${check}
482 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
483 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
484 if [[ -d ${EPATCH_SOURCE} ]] ; then
485 EPATCH_SOURCE=${EPATCH_SOURCE} \
486 EPATCH_SUFFIX="patch" \
487 EPATCH_FORCE="yes" \
488 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
489 epatch
490 echo "${EPATCH_SOURCE}" > "${applied}"
491 return 0
492 fi
493 done
494 echo "none" > "${applied}"
495 return 1
496}
497
498# @FUNCTION: emktemp
499# @USAGE: [temp dir]
500# @DESCRIPTION:
501# Cheap replacement for when debianutils (and thus mktemp)
502# does not exist on the users system.
503emktemp() {
504 local exe="touch"
505 [[ $1 == -d ]] && exe="mkdir" && shift
506 local topdir=$1
507
508 if [[ -z ${topdir} ]] ; then
509 [[ -z ${T} ]] \
510 && topdir="/tmp" \
511 || topdir=${T}
512 fi
513
514 if ! type -P mktemp > /dev/null ; then
515 # system lacks `mktemp` so we have to fake it
516 local tmp=/
517 while [[ -e ${tmp} ]] ; do
518 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
519 done
520 ${exe} "${tmp}" || ${exe} -p "${tmp}"
521 echo "${tmp}"
168 else 522 else
169 if [ ! -d ${EPATCH_SOURCE} ] 523 # the args here will give slightly wierd names on BSD,
170 then 524 # but should produce a usable file on all userlands
171 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 525 if [[ ${exe} == "touch" ]] ; then
172 then 526 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
173 EPATCH_SOURCE="$1" 527 else
528 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
174 fi 529 fi
175
176 echo
177 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
178 eerror
179 eerror " ${EPATCH_SOURCE}"
180 echo
181 die "Cannot find \$EPATCH_SOURCE!"
182 fi 530 fi
531}
183 532
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}" 533# @FUNCTION: egetent
185 fi 534# @USAGE: <database> <key>
186 535# @MAINTAINER:
187 case ${EPATCH_SUFFIX##*\.} in 536# base-system@gentoo.org (Linux)
188 bz2) 537# Joe Jezak <josejx@gmail.com> (OS X)
189 PIPE_CMD="bzip2 -dc" 538# usata@gentoo.org (OS X)
190 PATCH_SUFFIX="bz2" 539# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
540# @DESCRIPTION:
541# Small wrapper for getent (Linux),
542# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
543# and pw (FreeBSD) used in enewuser()/enewgroup()
544egetent() {
545 case ${CHOST} in
546 *-darwin[678])
547 case "$2" in
548 *[!0-9]*) # Non numeric
549 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
191 ;; 550 ;;
192 gz|Z|z) 551 *) # Numeric
193 PIPE_CMD="gzip -dc" 552 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
194 PATCH_SUFFIX="gz"
195 ;; 553 ;;
196 ZIP|zip) 554 esac
197 PIPE_CMD="unzip -p" 555 ;;
198 PATCH_SUFFIX="zip" 556 *-darwin*)
557 local mytype=$1
558 [[ "passwd" == $mytype ]] && mytype="Users"
559 [[ "group" == $mytype ]] && mytype="Groups"
560 case "$2" in
561 *[!0-9]*) # Non numeric
562 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
199 ;; 563 ;;
200 *) 564 *) # Numeric
201 PIPE_CMD="cat" 565 local mykey="UniqueID"
202 PATCH_SUFFIX="patch" 566 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
567 dscl . -search /$mytype $mykey $2 2>/dev/null
203 ;; 568 ;;
569 esac
570 ;;
571 *-freebsd*|*-dragonfly*)
572 local opts action="user"
573 [[ $1 == "passwd" ]] || action="group"
574
575 # lookup by uid/gid
576 if [[ $2 == [[:digit:]]* ]] ; then
577 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
578 fi
579
580 pw show ${action} ${opts} "$2" -q
581 ;;
582 *-netbsd*|*-openbsd*)
583 grep "$2:\*:" /etc/$1
584 ;;
585 *)
586 type -p nscd >& /dev/null && nscd -i "$1"
587 getent "$1" "$2"
588 ;;
204 esac 589 esac
205
206 if [ "${SINGLE_PATCH}" = "no" ]
207 then
208 einfo "Applying various patches (bugfixes/updates)..."
209 fi
210 for x in ${EPATCH_SOURCE}
211 do
212 # New ARCH dependant patch naming scheme...
213 #
214 # ???_arch_foo.patch
215 #
216 if [ -f ${x} ] && \
217 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
218 [ "${EPATCH_FORCE}" = "yes" ])
219 then
220 local count=0
221 local popts="${EPATCH_OPTS}"
222
223 if [ -n "${EPATCH_EXCLUDE}" ]
224 then
225 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
226 then
227 continue
228 fi
229 fi
230
231 if [ "${SINGLE_PATCH}" = "yes" ]
232 then
233 if [ -n "${EPATCH_SINGLE_MSG}" ]
234 then
235 einfo "${EPATCH_SINGLE_MSG}"
236 else
237 einfo "Applying ${x##*/}..."
238 fi
239 else
240 einfo " ${x##*/}..."
241 fi
242
243 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
244 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245
246 # Allow for prefix to differ ... im lazy, so shoot me :/
247 while [ "${count}" -lt 5 ]
248 do
249 # Generate some useful debug info ...
250 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
251 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
252
253 if [ "${PATCH_SUFFIX}" != "patch" ]
254 then
255 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
256 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
257 else
258 PATCH_TARGET="${x}"
259 fi
260
261 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
262 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
263
264 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
265 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
266
267 if [ "${PATCH_SUFFIX}" != "patch" ]
268 then
269 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
270 then
271 echo
272 eerror "Could not extract patch!"
273 #die "Could not extract patch!"
274 count=5
275 break
276 fi
277 fi
278
279 if (cat ${PATCH_TARGET} | patch ${popts} --dry-run -f -p${count}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
280 then
281 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
282 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
283 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
284 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
285 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
286
287 cat ${PATCH_TARGET} | patch ${popts} -p${count} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
288
289 if [ "$?" -ne 0 ]
290 then
291 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
292 echo
293 eerror "A dry-run of patch command succeeded, but actually"
294 eerror "applying the patch failed!"
295 #die "Real world sux compared to the dreamworld!"
296 count=5
297 fi
298
299 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
300
301 break
302 fi
303
304 count=$((count + 1))
305 done
306
307 if [ "${PATCH_SUFFIX}" != "patch" ]
308 then
309 rm -f ${PATCH_TARGET}
310 fi
311
312 if [ "${count}" -eq 5 ]
313 then
314 echo
315 eerror "Failed Patch: ${x##*/}!"
316 eerror
317 eerror "Include in your bugreport the contents of:"
318 eerror
319 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
320 echo
321 die "Failed Patch: ${x##*/}!"
322 fi
323
324 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
325
326 eend 0
327 fi
328 done
329 if [ "${SINGLE_PATCH}" = "no" ]
330 then
331 einfo "Done with patching"
332 fi
333} 590}
334 591
335# This function return true if we are using the NPTL pthreads 592# @FUNCTION: enewuser
336# implementation. 593# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
337# 594# @DESCRIPTION:
338# <azarah@gentoo.org> (06 March 2003) 595# Same as enewgroup, you are not required to understand how to properly add
339# 596# a user to the system. The only required parameter is the username.
340 597# Default uid is (pass -1 for this) next available, default shell is
341have_NPTL() { 598# /bin/false, default homedir is /dev/null, there are no default groups,
342 599# and default params sets the comment as 'added by portage for ${PN}'.
343 cat > ${T}/test-nptl.c <<-"END"
344 #define _XOPEN_SOURCE
345 #include <unistd.h>
346 #include <stdio.h>
347
348 int main()
349 {
350 char buf[255];
351 char *str = buf;
352
353 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
354 if (NULL != str) {
355 printf("%s\n", str);
356 if (NULL != strstr(str, "NPTL"))
357 return 0;
358 }
359
360 return 1;
361 }
362 END
363
364 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
365 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
366 then
367 echo "yes"
368 einfon "Checking what PTHREADS implementation we have ... "
369 if ${T}/nptl
370 then
371 return 0
372 else
373 return 1
374 fi
375 else
376 echo "no"
377 fi
378
379 return 1
380}
381
382# This function check how many cpu's are present, and then set
383# -j in MAKEOPTS accordingly.
384#
385# Thanks to nall <nall@gentoo.org> for this.
386#
387get_number_of_jobs() {
388 local jobs=0
389
390 if [ ! -r /proc/cpuinfo ]
391 then
392 return 1
393 fi
394
395 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
396 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
397 then
398 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
399 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
400 ADMINPARAM="${ADMINPARAM/-j}"
401 fi
402
403 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
404
405 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
406 "${ARCH}" = "arm" -o "${ARCH}" = "mips" ]
407 then
408 # these archs will always have "[Pp]rocessor"
409 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
410
411 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
412 then
413 # sparc always has "ncpus active"
414 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
415
416 elif [ "${ARCH}" = "alpha" ]
417 then
418 # alpha has "cpus active", but only when compiled with SMP
419 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
420 then
421 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
422 else
423 jobs=2
424 fi
425
426 elif [ "${ARCH}" = "ppc" ]
427 then
428 # ppc has "processor", but only when compiled with SMP
429 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
430 then
431 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
432 else
433 jobs=2
434 fi
435 else
436 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
437 die "Unknown ARCH -- ${ARCH}!"
438 fi
439
440 # Make sure the number is valid ...
441 if [ "${jobs}" -lt 1 ]
442 then
443 jobs=1
444 fi
445
446 if [ -n "${ADMINPARAM}" ]
447 then
448 if [ "${jobs}" -gt "${ADMINPARAM}" ]
449 then
450 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
451 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
452 else
453 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
454 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
455 fi
456 fi
457}
458
459# Simplify/standardize adding users to the system
460# vapier@gentoo.org
461#
462# enewuser(username, uid, shell, homedir, groups, extra options)
463#
464# Default values if you do not specify any:
465# username: REQUIRED !
466# uid: next available (see useradd(8))
467# note: pass -1 to get default behavior
468# shell: /bin/false
469# homedir: /dev/null
470# groups: none
471# extra: comment of 'added by portage for ${PN}'
472enewuser() { 600enewuser() {
601 case ${EBUILD_PHASE} in
602 unpack|compile|test|install)
603 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
604 eerror "Package fails at QA and at life. Please file a bug."
605 die "Bad package! enewuser is only for use in pkg_* functions!"
606 esac
607
473 # get the username 608 # get the username
474 local euser="$1"; shift 609 local euser=$1; shift
475 if [ -z "${euser}" ] ; then 610 if [[ -z ${euser} ]] ; then
476 eerror "No username specified !" 611 eerror "No username specified !"
477 die "Cannot call enewuser without a username" 612 die "Cannot call enewuser without a username"
478 fi 613 fi
614
615 # lets see if the username already exists
616 if [[ -n $(egetent passwd "${euser}") ]] ; then
617 return 0
618 fi
479 einfo "Adding user '${euser}' to your system ..." 619 einfo "Adding user '${euser}' to your system ..."
480 620
481 # setup a file for testing usernames/groups
482 local tmpfile="`mktemp -p ${T}`"
483 touch ${tmpfile}
484 chown ${euser} ${tmpfile} >& /dev/null
485 local realuser="`ls -l ${tmpfile} | awk '{print $3}'`"
486
487 # see if user already exists
488 if [ "${euser}" == "${realuser}" ] ; then
489 einfo "${euser} already exists on your system :)"
490 return 0
491 fi
492
493 # options to pass to useradd 621 # options to pass to useradd
494 local opts="" 622 local opts=
495 623
496 # handle uid 624 # handle uid
497 local euid="$1"; shift 625 local euid=$1; shift
498 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ] ; then 626 if [[ -n ${euid} && ${euid} != -1 ]] ; then
499 if [ ${euid} -gt 0 ] ; then 627 if [[ ${euid} -gt 0 ]] ; then
500 opts="${opts} -u ${euid}" 628 if [[ -n $(egetent passwd ${euid}) ]] ; then
629 euid="next"
630 fi
501 else 631 else
502 eerror "Userid given but is not greater than 0 !" 632 eerror "Userid given but is not greater than 0 !"
503 die "${euid} is not a valid UID" 633 die "${euid} is not a valid UID"
504 fi 634 fi
505 else 635 else
506 euid="next available" 636 euid="next"
507 fi 637 fi
638 if [[ ${euid} == "next" ]] ; then
639 for ((euid = 101; euid <= 999; euid++)); do
640 [[ -z $(egetent passwd ${euid}) ]] && break
641 done
642 fi
643 opts="${opts} -u ${euid}"
508 einfo " - Userid: ${euid}" 644 einfo " - Userid: ${euid}"
509 645
510 # handle shell 646 # handle shell
511 local eshell="$1"; shift 647 local eshell=$1; shift
512 if [ ! -z "${eshell}" ] ; then 648 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
513 if [ ! -e ${eshell} ] ; then 649 if [[ ! -e ${ROOT}${eshell} ]] ; then
514 eerror "A shell was specified but it does not exist !" 650 eerror "A shell was specified but it does not exist !"
515 die "${eshell} does not exist" 651 die "${eshell} does not exist in ${ROOT}"
652 fi
653 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
654 eerror "Do not specify ${eshell} yourself, use -1"
655 die "Pass '-1' as the shell parameter"
516 fi 656 fi
517 else 657 else
518 eshell=/bin/false 658 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
659 [[ -x ${ROOT}${shell} ]] && break
660 done
661
662 if [[ ${shell} == "/dev/null" ]] ; then
663 eerror "Unable to identify the shell to use, proceeding with userland default."
664 case ${USERLAND} in
665 GNU) shell="/bin/false" ;;
666 BSD) shell="/sbin/nologin" ;;
667 Darwin) shell="/usr/sbin/nologin" ;;
668 *) die "Unable to identify the default shell for userland ${USERLAND}"
669 esac
670 fi
671
672 eshell=${shell}
519 fi 673 fi
520 einfo " - Shell: ${eshell}" 674 einfo " - Shell: ${eshell}"
521 opts="${opts} -s ${eshell}" 675 opts="${opts} -s ${eshell}"
522 676
523 # handle homedir 677 # handle homedir
524 local ehome="$1"; shift 678 local ehome=$1; shift
525 if [ -z "${ehome}" ] ; then 679 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
526 ehome=/dev/null 680 ehome="/dev/null"
527 fi 681 fi
528 einfo " - Home: ${ehome}" 682 einfo " - Home: ${ehome}"
529 opts="${opts} -d ${ehome}" 683 opts="${opts} -d ${ehome}"
530 684
531 # handle groups 685 # handle groups
532 local egroups="$1"; shift 686 local egroups=$1; shift
533 if [ ! -z "${egroups}" ] ; then 687 if [[ ! -z ${egroups} ]] ; then
534 local realgroup
535 local oldifs="${IFS}" 688 local oldifs=${IFS}
689 local defgroup="" exgroups=""
690
536 export IFS="," 691 export IFS=","
537 for g in ${egroups} ; do 692 for g in ${egroups} ; do
538 chgrp ${g} ${tmpfile} >& /dev/null 693 export IFS=${oldifs}
539 realgroup="`ls -l ${tmpfile} | awk '{print $4}'`" 694 if [[ -z $(egetent group "${g}") ]] ; then
540 if [ "${g}" != "${realgroup}" ] ; then
541 eerror "You must add ${g} to the system first" 695 eerror "You must add group ${g} to the system first"
542 die "${g} is not a valid GID" 696 die "${g} is not a valid GID"
543 fi 697 fi
698 if [[ -z ${defgroup} ]] ; then
699 defgroup=${g}
700 else
701 exgroups="${exgroups},${g}"
702 fi
703 export IFS=","
544 done 704 done
545 export IFS="${oldifs}" 705 export IFS=${oldifs}
706
546 opts="${opts} -g ${egroups}" 707 opts="${opts} -g ${defgroup}"
708 if [[ ! -z ${exgroups} ]] ; then
709 opts="${opts} -G ${exgroups:1}"
710 fi
547 else 711 else
548 egroups="(none)" 712 egroups="(none)"
549 fi 713 fi
550 einfo " - Groups: ${egroups}" 714 einfo " - Groups: ${egroups}"
551 715
552 # handle extra and add the user 716 # handle extra and add the user
553 local eextra="$@"
554 local oldsandbox=${SANDBOX_ON} 717 local oldsandbox=${SANDBOX_ON}
555 export SANDBOX_ON="0" 718 export SANDBOX_ON="0"
556 if [ -z "${eextra}" ] ; then 719 case ${CHOST} in
557 useradd ${opts} ${euser} \ 720 *-darwin*)
721 ### Make the user
722 if [[ -z $@ ]] ; then
723 dscl . create /users/${euser} uid ${euid}
724 dscl . create /users/${euser} shell ${eshell}
725 dscl . create /users/${euser} home ${ehome}
726 dscl . create /users/${euser} realname "added by portage for ${PN}"
727 ### Add the user to the groups specified
728 local oldifs=${IFS}
729 export IFS=","
730 for g in ${egroups} ; do
731 dscl . merge /groups/${g} users ${euser}
732 done
733 export IFS=${oldifs}
734 else
735 einfo "Extra options are not supported on Darwin yet"
736 einfo "Please report the ebuild along with the info below"
737 einfo "eextra: $@"
738 die "Required function missing"
739 fi
740 ;;
741 *-freebsd*|*-dragonfly*)
742 if [[ -z $@ ]] ; then
743 pw useradd ${euser} ${opts} \
558 -c "added by portage for ${PN}" \ 744 -c "added by portage for ${PN}" \
745 die "enewuser failed"
746 else
747 einfo " - Extra: $@"
748 pw useradd ${euser} ${opts} \
749 "$@" || die "enewuser failed"
750 fi
751 ;;
752
753 *-netbsd*)
754 if [[ -z $@ ]] ; then
755 useradd ${opts} ${euser} || die "enewuser failed"
756 else
757 einfo " - Extra: $@"
758 useradd ${opts} ${euser} "$@" || die "enewuser failed"
759 fi
760 ;;
761
762 *-openbsd*)
763 if [[ -z $@ ]] ; then
764 useradd -u ${euid} -s ${eshell} \
765 -d ${ehome} -c "Added by portage for ${PN}" \
766 -g ${egroups} ${euser} || die "enewuser failed"
767 else
768 einfo " - Extra: $@"
769 useradd -u ${euid} -s ${eshell} \
770 -d ${ehome} -c "Added by portage for ${PN}" \
771 -g ${egroups} ${euser} "$@" || die "enewuser failed"
772 fi
773 ;;
774
775 *)
776 if [[ -z $@ ]] ; then
777 useradd -r ${opts} \
778 -c "added by portage for ${PN}" \
779 ${euser} \
559 || die "enewuser failed" 780 || die "enewuser failed"
560 else 781 else
561 einfo " - Extra: ${eextra}" 782 einfo " - Extra: $@"
562 useradd ${opts} ${euser} ${eextra} \ 783 useradd -r ${opts} "$@" \
784 ${euser} \
563 || die "enewuser failed" 785 || die "enewuser failed"
564 fi 786 fi
787 ;;
788 esac
789
790 if [[ ! -e ${ROOT}/${ehome} ]] ; then
791 einfo " - Creating ${ehome} in ${ROOT}"
792 mkdir -p "${ROOT}/${ehome}"
793 chown ${euser} "${ROOT}/${ehome}"
794 chmod 755 "${ROOT}/${ehome}"
795 fi
796
565 export SANDBOX_ON="${oldsandbox}" 797 export SANDBOX_ON=${oldsandbox}
566
567 if [ ! -e ${ehome} ] && [ ! -e ${D}/${ehome} ] ; then
568 einfo " - Creating ${ehome} in ${D}"
569 dodir ${ehome}
570 fowners ${euser} ${ehome}
571 fperms 755 ${ehome}
572 fi
573} 798}
574 799
575# Simplify/standardize adding groups to the system 800# @FUNCTION: enewgroup
576# vapier@gentoo.org 801# @USAGE: <group> [gid]
577# 802# @DESCRIPTION:
578# enewgroup(group, gid) 803# This function does not require you to understand how to properly add a
579# 804# group to the system. Just give it a group name to add and enewgroup will
580# Default values if you do not specify any: 805# do the rest. You may specify the gid for the group or allow the group to
581# groupname: REQUIRED ! 806# allocate the next available one.
582# gid: next available (see groupadd(8))
583# extra: none
584enewgroup() { 807enewgroup() {
808 case ${EBUILD_PHASE} in
809 unpack|compile|test|install)
810 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
811 eerror "Package fails at QA and at life. Please file a bug."
812 die "Bad package! enewgroup is only for use in pkg_* functions!"
813 esac
814
585 # get the group 815 # get the group
586 local egroup="$1"; shift 816 local egroup="$1"; shift
587 if [ -z "${egroup}" ] ; then 817 if [ -z "${egroup}" ]
818 then
588 eerror "No group specified !" 819 eerror "No group specified !"
589 die "Cannot call enewgroup without a group" 820 die "Cannot call enewgroup without a group"
590 fi 821 fi
822
823 # see if group already exists
824 if [[ -n $(egetent group "${egroup}") ]]; then
825 return 0
826 fi
591 einfo "Adding group '${egroup}' to your system ..." 827 einfo "Adding group '${egroup}' to your system ..."
592 828
593 # setup a file for testing groupname
594 local tmpfile="`mktemp -p ${T}`"
595 touch ${tmpfile}
596 chgrp ${egroup} ${tmpfile} >& /dev/null
597 local realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
598
599 # see if group already exists
600 if [ "${egroup}" == "${realgroup}" ] ; then
601 einfo "${egroup} already exists on your system :)"
602 return 0
603 fi
604
605 # options to pass to useradd 829 # options to pass to useradd
606 local opts="" 830 local opts=
607 831
608 # handle gid 832 # handle gid
609 local egid="$1"; shift 833 local egid="$1"; shift
610 if [ ! -z "${egid}" ] ; then 834 if [ ! -z "${egid}" ]
835 then
611 if [ ${egid} -gt 0 ] ; then 836 if [ "${egid}" -gt 0 ]
837 then
838 if [ -z "`egetent group ${egid}`" ]
839 then
840 if [[ "${CHOST}" == *-darwin* ]]; then
841 opts="${opts} ${egid}"
842 else
612 opts="${opts} -g ${egid}" 843 opts="${opts} -g ${egid}"
844 fi
845 else
846 egid="next available; requested gid taken"
847 fi
613 else 848 else
614 eerror "Groupid given but is not greater than 0 !" 849 eerror "Groupid given but is not greater than 0 !"
615 die "${egid} is not a valid GID" 850 die "${egid} is not a valid GID"
616 fi 851 fi
617 else 852 else
622 # handle extra 857 # handle extra
623 local eextra="$@" 858 local eextra="$@"
624 opts="${opts} ${eextra}" 859 opts="${opts} ${eextra}"
625 860
626 # add the group 861 # add the group
627 local oldsandbox=${SANDBOX_ON} 862 local oldsandbox="${SANDBOX_ON}"
628 export SANDBOX_ON="0" 863 export SANDBOX_ON="0"
864 case ${CHOST} in
865 *-darwin*)
866 if [ ! -z "${eextra}" ];
867 then
868 einfo "Extra options are not supported on Darwin/OS X yet"
869 einfo "Please report the ebuild along with the info below"
870 einfo "eextra: ${eextra}"
871 die "Required function missing"
872 fi
873
874 # If we need the next available
875 case ${egid} in
876 *[!0-9]*) # Non numeric
877 for ((egid = 101; egid <= 999; egid++)); do
878 [[ -z $(egetent group ${egid}) ]] && break
879 done
880 esac
881 dscl . create /groups/${egroup} gid ${egid}
882 dscl . create /groups/${egroup} passwd '*'
883 ;;
884
885 *-freebsd*|*-dragonfly*)
886 case ${egid} in
887 *[!0-9]*) # Non numeric
888 for ((egid = 101; egid <= 999; egid++)); do
889 [[ -z $(egetent group ${egid}) ]] && break
890 done
891 esac
892 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
893 ;;
894
895 *-netbsd*)
896 case ${egid} in
897 *[!0-9]*) # Non numeric
898 for ((egid = 101; egid <= 999; egid++)); do
899 [[ -z $(egetent group ${egid}) ]] && break
900 done
901 esac
902 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
903 ;;
904
905 *)
906 # We specify -r so that we get a GID in the system range from login.defs
629 groupadd ${opts} ${egroup} || die "enewgroup failed" 907 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
908 ;;
909 esac
630 export SANDBOX_ON="${oldsandbox}" 910 export SANDBOX_ON="${oldsandbox}"
631} 911}
632 912
633# Simple script to replace 'dos2unix' binaries 913# @FUNCTION: edos2unix
634# vapier@gentoo.org 914# @USAGE: <file> [more files ...]
635# 915# @DESCRIPTION:
636# edos2unix(file, <more files>...) 916# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
917# to remove all of these text utilities from DEPEND variables because this
918# is a script based solution. Just give it a list of files to convert and
919# they will all be changed from the DOS CRLF format to the UNIX LF format.
637edos2unix() { 920edos2unix() {
638 for f in $@ ; do 921 echo "$@" | xargs sed -i 's/\r$//'
639 cp ${f} ${T}/edos2unix
640 sed 's/\r$//' ${T}/edos2unix > ${f}
641 done
642} 922}
643 923
644# Make a desktop file ! 924# Make a desktop file !
645# Great for making those icons in kde/gnome startmenu ! 925# Great for making those icons in kde/gnome startmenu !
646# Amaze your friends ! Get the women ! Join today ! 926# Amaze your friends ! Get the women ! Join today !
647# gnome2 /usr/share/applications
648# gnome1 /usr/share/gnome/apps/
649# KDE ${KDEDIR}/share/applnk /usr/share/applnk
650# 927#
651# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 928# make_desktop_entry(<command>, [name], [icon], [type], [fields])
652# 929#
653# binary: what binary does the app run with ? 930# binary: what command does the app run with ?
654# name: the name that will show up in the menu 931# name: the name that will show up in the menu
655# icon: give your little like a pretty little icon ... 932# icon: give your little like a pretty little icon ...
656# this can be relative (to /usr/share/pixmaps) or 933# this can be relative (to /usr/share/pixmaps) or
657# a full path to an icon 934# a full path to an icon
658# type: what kind of application is this ? for categories: 935# type: what kind of application is this ? for categories:
659# http://www.freedesktop.org/standards/menu/draft/menu-spec/menu-spec.html 936# http://standards.freedesktop.org/menu-spec/latest/apa.html
660# path: if your app needs to startup in a specific dir 937# fields: extra fields to append to the desktop file; a printf string
661make_desktop_entry() { 938make_desktop_entry() {
662 [ -z "$1" ] && eerror "You must specify the executable" && return 1 939 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
663 940
664 local exec=${1} 941 local exec=${1}
665 local name=${2:-${PN}} 942 local name=${2:-${PN}}
666 local icon=${3:-${PN}.png} 943 local icon=${3:-${PN}}
667 local type=${4} 944 local type=${4}
668 local path=${5:-${GAMES_PREFIX}} 945 local fields=${5}
946
669 if [ -z "${type}" ] ; then 947 if [[ -z ${type} ]] ; then
670 case ${CATEGORY} in 948 local catmaj=${CATEGORY%%-*}
949 local catmin=${CATEGORY##*-}
950 case ${catmaj} in
951 app)
952 case ${catmin} in
953 accessibility) type=Accessibility;;
954 admin) type=System;;
955 antivirus) type=System;;
956 arch) type=Archiving;;
957 backup) type=Archiving;;
958 cdr) type=DiscBurning;;
959 dicts) type=Dictionary;;
960 doc) type=Documentation;;
961 editors) type=TextEditor;;
962 emacs) type=TextEditor;;
963 emulation) type=Emulator;;
964 laptop) type=HardwareSettings;;
965 office) type=Office;;
966 pda) type=PDA;;
967 vim) type=TextEditor;;
968 xemacs) type=TextEditor;;
969 esac
970 ;;
971
972 dev)
973 type="Development"
974 ;;
975
976 games)
977 case ${catmin} in
978 action|fps) type=ActionGame;;
979 arcade) type=ArcadeGame;;
980 board) type=BoardGame;;
671 app-emulation) type=Emulator ;; 981 emulation) type=Emulator;;
672 app-games) type=Game ;; 982 kids) type=KidsGame;;
673 *) type="" ;; 983 puzzle) type=LogicGame;;
984 roguelike) type=RolePlaying;;
985 rpg) type=RolePlaying;;
986 simulation) type=Simulation;;
987 sports) type=SportsGame;;
988 strategy) type=StrategyGame;;
989 esac
990 type="Game;${type}"
991 ;;
992
993 gnome)
994 type="Gnome;GTK"
995 ;;
996
997 kde)
998 type="KDE;Qt"
999 ;;
1000
1001 mail)
1002 type="Network;Email"
1003 ;;
1004
1005 media)
1006 case ${catmin} in
1007 gfx)
1008 type=Graphics
1009 ;;
1010 *)
1011 case ${catmin} in
1012 radio) type=Tuner;;
1013 sound) type=Audio;;
1014 tv) type=TV;;
1015 video) type=Video;;
1016 esac
1017 type="AudioVideo;${type}"
1018 ;;
1019 esac
1020 ;;
1021
1022 net)
1023 case ${catmin} in
1024 dialup) type=Dialup;;
1025 ftp) type=FileTransfer;;
1026 im) type=InstantMessaging;;
1027 irc) type=IRCClient;;
1028 mail) type=Email;;
1029 news) type=News;;
1030 nntp) type=News;;
1031 p2p) type=FileTransfer;;
1032 voip) type=Telephony;;
1033 esac
1034 type="Network;${type}"
1035 ;;
1036
1037 sci)
1038 case ${catmin} in
1039 astro*) type=Astronomy;;
1040 bio*) type=Biology;;
1041 calc*) type=Calculator;;
1042 chem*) type=Chemistry;;
1043 elec*) type=Electronics;;
1044 geo*) type=Geology;;
1045 math*) type=Math;;
1046 physics) type=Physics;;
1047 visual*) type=DataVisualization;;
1048 esac
1049 type="Education;Science;${type}"
1050 ;;
1051
1052 sys)
1053 type="System"
1054 ;;
1055
1056 www)
1057 case ${catmin} in
1058 client) type=WebBrowser;;
1059 esac
1060 type="Network;${type}"
1061 ;;
1062
1063 *)
1064 type=
1065 ;;
674 esac 1066 esac
675 fi 1067 fi
1068 if [ "${SLOT}" == "0" ] ; then
1069 local desktop_name="${PN}"
1070 else
1071 local desktop_name="${PN}-${SLOT}"
1072 fi
1073 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
676 local desktop=${T}/${exec}.desktop 1074 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
677 1075
1076 # Don't append another ";" when a valid category value is provided.
1077 type=${type%;}${type:+;}
1078
1079 eshopts_push -s extglob
1080 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1081 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1082 ewarn "allowed in .desktop files if the value is not an absolute path."
1083 icon=${icon%.@(xpm|png|svg)}
1084 fi
1085 eshopts_pop
1086
1087 cat <<-EOF > "${desktop}"
678echo "[Desktop Entry] 1088 [Desktop Entry]
679Encoding=UTF-8
680Version=0.9.2
681Name=${name} 1089 Name=${name}
682Type=Application 1090 Type=Application
683Comment=${DESCRIPTION} 1091 Comment=${DESCRIPTION}
684Exec=${exec} 1092 Exec=${exec}
685Path=${path} 1093 TryExec=${exec%% *}
686Icon=${icon} 1094 Icon=${icon}
687Categories=Application;${type};" > ${desktop} 1095 Categories=${type}
1096 EOF
688 1097
689 if [ -d /usr/share/applications ] ; then 1098 if [[ ${fields:-=} != *=* ]] ; then
1099 # 5th arg used to be value to Path=
1100 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1101 fields="Path=${fields}"
1102 fi
1103 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1104
1105 (
1106 # wrap the env here so that the 'insinto' call
1107 # doesn't corrupt the env of the caller
690 insinto /usr/share/applications 1108 insinto /usr/share/applications
691 doins ${desktop} 1109 doins "${desktop}"
692 fi 1110 ) || die "installing desktop file failed"
1111}
693 1112
694 #if [ -d /usr/share/gnome/apps ] ; then 1113# @FUNCTION: validate_desktop_entries
695 # insinto /usr/share/gnome/apps/Games 1114# @USAGE: [directories]
696 # doins ${desktop} 1115# @MAINTAINER:
697 #fi 1116# Carsten Lohrke <carlo@gentoo.org>
698 1117# @DESCRIPTION:
699 #if [ ! -z "`ls /usr/kde/* 2>/dev/null`" ] ; then 1118# Validate desktop entries using desktop-file-utils
700 # for ver in /usr/kde/* ; do 1119validate_desktop_entries() {
701 # insinto ${ver}/share/applnk/Games 1120 if [[ -x /usr/bin/desktop-file-validate ]] ; then
702 # doins ${desktop} 1121 einfo "Checking desktop entry validity"
1122 local directories=""
1123 for d in /usr/share/applications $@ ; do
1124 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
703 # done 1125 done
704 #fi 1126 if [[ -n ${directories} ]] ; then
705 1127 for FILE in $(find ${directories} -name "*\.desktop" \
706 if [ -d /usr/share/applnk ] ; then 1128 -not -path '*.hidden*' | sort -u 2>/dev/null)
707 insinto /usr/share/applnk/${type} 1129 do
708 doins ${desktop} 1130 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
709 fi 1131 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
710 1132 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
711 return 0
712}
713
714# new convenience patch wrapper function to eventually replace epatch(),
715# $PATCHES, $PATCHES1, src_unpack:patch, src_unpack:autopatch and
716# /usr/bin/patch
717# Features:
718# - bulk patch handling similar to epatch()'s
719# - automatic patch level detection like epatch()'s
720# - automatic patch uncompression like epatch()'s
721# - doesn't have the --dry-run overhead of epatch() - inspects patchfiles
722# manually instead
723# - once I decide it's production-ready, it'll be called from base_src_unpack
724# to handle $PATCHES to avoid defining src_unpack just to use xpatch
725
726# accepts zero or more parameters specifying patchfiles and/or patchdirs
727
728# known issues:
729# - only supports unified style patches (does anyone _really_ use anything
730# else?)
731# - because it doesn't use --dry-run there is a risk of it failing
732# to find the files to patch, ie detect the patchlevel, properly. It doesn't use
733# any of the backup heuristics that patch employs to discover a filename.
734# however, this isn't dangerous because if it works for the developer who's
735# writing the ebuild, it'll always work for the users, and if it doesn't,
736# then we'll fix it :-)
737# - no support as yet for patches applying outside $S (and not directly in $WORKDIR).
738xpatch() {
739
740 debug-print-function $FUNCNAME $*
741
742 local list=""
743 local list2=""
744 declare -i plevel
745
746 # parse patch sources
747 for x in $*; do
748 debug-print "$FUNCNAME: parsing parameter $x"
749 if [ -f "$x" ]; then
750 list="$list $x"
751 elif [ -d "$x" ]; then
752 # handles patchdirs like epatch() for now: no recursion.
753 # patches are sorted by filename, so with an xy_foo naming scheme you'll get the right order.
754 # only patches with _$ARCH_ or _all_ in their filenames are applied.
755 for file in `ls -A $x`; do
756 debug-print "$FUNCNAME: parsing in subdir: file $file"
757 if [ -f "$x/$file" ] && [ "${file}" != "${file/_all_}" -o "${file}" != "${file/_$ARCH_}" ]; then
758 list2="$list2 $x/$file"
759 fi
760 done 1133 done
761 list="`echo $list2 | sort` $list" 1134 fi
1135 echo ""
1136 else
1137 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1138 fi
1139}
1140
1141# @FUNCTION: make_session_desktop
1142# @USAGE: <title> <command> [command args...]
1143# @DESCRIPTION:
1144# Make a GDM/KDM Session file. The title is the file to execute to start the
1145# Window Manager. The command is the name of the Window Manager.
1146#
1147# You can set the name of the file via the ${wm} variable.
1148make_session_desktop() {
1149 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1150 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1151
1152 local title=$1
1153 local command=$2
1154 local desktop=${T}/${wm:-${PN}}.desktop
1155 shift 2
1156
1157 cat <<-EOF > "${desktop}"
1158 [Desktop Entry]
1159 Name=${title}
1160 Comment=This session logs you into ${title}
1161 Exec=${command} $*
1162 TryExec=${command}
1163 Type=XSession
1164 EOF
1165
1166 (
1167 # wrap the env here so that the 'insinto' call
1168 # doesn't corrupt the env of the caller
1169 insinto /usr/share/xsessions
1170 doins "${desktop}"
1171 )
1172}
1173
1174# @FUNCTION: domenu
1175# @USAGE: <menus>
1176# @DESCRIPTION:
1177# Install the list of .desktop menu files into the appropriate directory
1178# (/usr/share/applications).
1179domenu() {
1180 (
1181 # wrap the env here so that the 'insinto' call
1182 # doesn't corrupt the env of the caller
1183 local i j ret=0
1184 insinto /usr/share/applications
1185 for i in "$@" ; do
1186 if [[ -f ${i} ]] ; then
1187 doins "${i}"
1188 ((ret+=$?))
1189 elif [[ -d ${i} ]] ; then
1190 for j in "${i}"/*.desktop ; do
1191 doins "${j}"
1192 ((ret+=$?))
1193 done
762 else 1194 else
763 die "Couldn't find $x" 1195 ((++ret))
764 fi 1196 fi
765 done 1197 done
1198 exit ${ret}
1199 )
1200}
766 1201
767 debug-print "$FUNCNAME: final list of patches: $list" 1202# @FUNCTION: newmenu
1203# @USAGE: <menu> <newname>
1204# @DESCRIPTION:
1205# Like all other new* functions, install the specified menu as newname.
1206newmenu() {
1207 (
1208 # wrap the env here so that the 'insinto' call
1209 # doesn't corrupt the env of the caller
1210 insinto /usr/share/applications
1211 newins "$@"
1212 )
1213}
768 1214
769 for x in $list; do 1215# @FUNCTION: doicon
770 debug-print "$FUNCNAME: processing $x" 1216# @USAGE: <list of icons>
771 # deal with compressed files. /usr/bin/file is in the system profile, or should be. 1217# @DESCRIPTION:
772 case "`/usr/bin/file -b $x`" in 1218# Install the list of icons into the icon directory (/usr/share/pixmaps).
773 *gzip*) patchfile="${T}/current.patch"; ungzip -c "$x" > "${patchfile}";; 1219# This is useful in conjunction with creating desktop/menu files.
774 *bzip2*) patchfile="${T}/current.patch"; bunzip2 -c "$x" > "${patchfile}";; 1220doicon() {
775 *text*) patchfile="$x";; 1221 (
776 *) die "Could not determine filetype of patch $x";; 1222 # wrap the env here so that the 'insinto' call
777 esac 1223 # doesn't corrupt the env of the caller
778 debug-print "$FUNCNAME: patchfile=$patchfile" 1224 local i j ret
779 1225 insinto /usr/share/pixmaps
780 # determine patchlevel. supports p0 and higher with either $S or $WORKDIR as base. 1226 for i in "$@" ; do
781 target="`/bin/grep -m 1 '^+++ ' $patchfile`" 1227 if [[ -f ${i} ]] ; then
782 debug-print "$FUNCNAME: raw target=$target" 1228 doins "${i}"
783 # strip target down to the path/filename, remove leading +++ 1229 ((ret+=$?))
784 target="${target/+++ }"; target="${target%% *}" 1230 elif [[ -d ${i} ]] ; then
785 # duplicate slashes are discarded by patch wrt the patchlevel. therefore we need 1231 for j in "${i}"/*.png ; do
786 # to discard them as well to calculate the correct patchlevel. 1232 doins "${j}"
787 target="${target//\/\//\/}" 1233 ((ret+=$?))
788 debug-print "$FUNCNAME: stripped target=$target"
789
790 # look for target
791 for basedir in "$S" "$WORKDIR" "${PWD}"; do
792 debug-print "$FUNCNAME: looking in basedir=$basedir"
793 cd "$basedir"
794
795 # try stripping leading directories
796 target2="$target"
797 plevel=0
798 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
799 while [ ! -f "$target2" ]; do
800 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
801 plevel=plevel+1
802 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
803 [ "$target2" == "${target2/\/}" ] && break
804 done 1234 done
805 test -f "$target2" && break 1235 else
806 1236 ((++ret))
807 # try stripping filename - needed to support patches creating new files 1237 fi
808 target2="${target%/*}"
809 plevel=0
810 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
811 while [ ! -d "$target2" ]; do
812 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
813 plevel=plevel+1
814 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
815 [ "$target2" == "${target2/\/}" ] && break
816 done
817 test -d "$target2" && break
818
819 done
820
821 test -f "${basedir}/${target2}" || test -d "${basedir}/${target2}" || die "Could not determine patchlevel for $x"
822 debug-print "$FUNCNAME: determined plevel=$plevel"
823 # do the patching
824 ebegin "Applying patch ${x##*/}..."
825 /usr/bin/patch -p$plevel < "$patchfile" > /dev/null || die "Failed to apply patch $x"
826 eend $?
827
828 done 1238 done
829 1239 exit ${ret}
1240 )
830} 1241}
831 1242
1243# @FUNCTION: newicon
1244# @USAGE: <icon> <newname>
1245# @DESCRIPTION:
1246# Like all other new* functions, install the specified icon as newname.
1247newicon() {
1248 (
1249 # wrap the env here so that the 'insinto' call
1250 # doesn't corrupt the env of the caller
1251 insinto /usr/share/pixmaps
1252 newins "$@"
1253 )
1254}
1255
1256# for internal use only (unpack_pdv and unpack_makeself)
1257find_unpackable_file() {
1258 local src=$1
1259 if [[ -z ${src} ]] ; then
1260 src=${DISTDIR}/${A}
1261 else
1262 if [[ -e ${DISTDIR}/${src} ]] ; then
1263 src=${DISTDIR}/${src}
1264 elif [[ -e ${PWD}/${src} ]] ; then
1265 src=${PWD}/${src}
1266 elif [[ -e ${src} ]] ; then
1267 src=${src}
1268 fi
1269 fi
1270 [[ ! -e ${src} ]] && return 1
1271 echo "${src}"
1272}
1273
1274# @FUNCTION: unpack_pdv
1275# @USAGE: <file to unpack> <size of off_t>
1276# @DESCRIPTION:
1277# Unpack those pesky pdv generated files ...
1278# They're self-unpacking programs with the binary package stuffed in
1279# the middle of the archive. Valve seems to use it a lot ... too bad
1280# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1281#
1282# You have to specify the off_t size ... I have no idea how to extract that
1283# information out of the binary executable myself. Basically you pass in
1284# the size of the off_t type (in bytes) on the machine that built the pdv
1285# archive.
1286#
1287# One way to determine this is by running the following commands:
1288#
1289# @CODE
1290# strings <pdv archive> | grep lseek
1291# strace -elseek <pdv archive>
1292# @CODE
1293#
1294# Basically look for the first lseek command (we do the strings/grep because
1295# sometimes the function call is _llseek or something) and steal the 2nd
1296# parameter. Here is an example:
1297#
1298# @CODE
1299# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1300# lseek
1301# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1302# lseek(3, -4, SEEK_END) = 2981250
1303# @CODE
1304#
1305# Thus we would pass in the value of '4' as the second parameter.
1306unpack_pdv() {
1307 local src=$(find_unpackable_file "$1")
1308 local sizeoff_t=$2
1309
1310 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1311 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1312
1313 local shrtsrc=$(basename "${src}")
1314 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1315 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1316 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1317
1318 # grab metadata for debug reasons
1319 local metafile=$(emktemp)
1320 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1321
1322 # rip out the final file name from the metadata
1323 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1324 datafile=$(basename "${datafile}")
1325
1326 # now lets uncompress/untar the file if need be
1327 local tmpfile=$(emktemp)
1328 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1329
1330 local iscompressed=$(file -b "${tmpfile}")
1331 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1332 iscompressed=1
1333 mv ${tmpfile}{,.Z}
1334 gunzip ${tmpfile}
1335 else
1336 iscompressed=0
1337 fi
1338 local istar=$(file -b "${tmpfile}")
1339 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1340 istar=1
1341 else
1342 istar=0
1343 fi
1344
1345 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1346 #dd if=${src} ibs=${metaskip} count=1 \
1347 # | dd ibs=${tailskip} skip=1 \
1348 # | gzip -dc \
1349 # > ${datafile}
1350 if [ ${iscompressed} -eq 1 ] ; then
1351 if [ ${istar} -eq 1 ] ; then
1352 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1353 | head -c $((${metaskip}-${tailskip})) \
1354 | tar -xzf -
1355 else
1356 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1357 | head -c $((${metaskip}-${tailskip})) \
1358 | gzip -dc \
1359 > ${datafile}
1360 fi
1361 else
1362 if [ ${istar} -eq 1 ] ; then
1363 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1364 | head -c $((${metaskip}-${tailskip})) \
1365 | tar --no-same-owner -xf -
1366 else
1367 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1368 | head -c $((${metaskip}-${tailskip})) \
1369 > ${datafile}
1370 fi
1371 fi
1372 true
1373 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1374 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1375}
1376
1377# @FUNCTION: unpack_makeself
1378# @USAGE: [file to unpack] [offset] [tail|dd]
1379# @DESCRIPTION:
832# Unpack those pesky makeself generated files ... 1380# Unpack those pesky makeself generated files ...
833# They're shell scripts with the binary package tagged onto 1381# They're shell scripts with the binary package tagged onto
834# the end of the archive. Loki utilized the format as does 1382# the end of the archive. Loki utilized the format as does
835# many other game companies. 1383# many other game companies.
836# 1384#
837# Usage: unpack_makeself [file to unpack] [offset] 1385# If the file is not specified, then ${A} is used. If the
838# - If the file is not specified then unpack will utilize ${A}.
839# - If the offset is not specified then we will attempt to extract 1386# offset is not specified then we will attempt to extract
840# the proper offset from the script itself. 1387# the proper offset from the script itself.
841unpack_makeself() { 1388unpack_makeself() {
842 local src=$1 1389 local src_input=${1:-${A}}
1390 local src=$(find_unpackable_file "${src_input}")
843 local skip=$2 1391 local skip=$2
1392 local exe=$3
844 1393
845 [ -z "${src}" ] && src=${A} 1394 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
846 [ -e ./${src} ] \ 1395
847 && src=${PWD}/${src} \
848 || src=${DISTDIR}/${src}
849 local shrtsrc=`basename ${src}` 1396 local shrtsrc=$(basename "${src}")
850 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1397 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
851 if [ -z "${skip}" ] ; then 1398 if [[ -z ${skip} ]] ; then
852 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1399 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
853 local skip=0 1400 local skip=0
1401 exe=tail
854 case ${ver} in 1402 case ${ver} in
855 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1403 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
856 skip=`grep -a ^skip= ${src} | cut -d= -f2` 1404 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
857 ;; 1405 ;;
858 2.0|2.0.1) 1406 2.0|2.0.1)
859 skip=`grep -a ^$'\t'tail ${src} | awk '{print $2}' | cut -b2-` 1407 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
860 ;; 1408 ;;
861 2.1.1) 1409 2.1.1)
862 skip=`grep -a ^offset= ${src} | awk '{print $2}' | cut -b2-` 1410 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
863 let skip="skip + 1" 1411 (( skip++ ))
1412 ;;
1413 2.1.2)
1414 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1415 (( skip++ ))
1416 ;;
1417 2.1.3)
1418 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1419 (( skip++ ))
1420 ;;
1421 2.1.4|2.1.5)
1422 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1423 skip=$(head -n ${skip} "${src}" | wc -c)
1424 exe="dd"
864 ;; 1425 ;;
865 *) 1426 *)
866 eerror "I'm sorry, but I was unable to support the Makeself file." 1427 eerror "I'm sorry, but I was unable to support the Makeself file."
867 eerror "The version I detected was '${ver}'." 1428 eerror "The version I detected was '${ver}'."
868 eerror "Please file a bug about the file ${shrtsrc} at" 1429 eerror "Please file a bug about the file ${shrtsrc} at"
870 die "makeself version '${ver}' not supported" 1431 die "makeself version '${ver}' not supported"
871 ;; 1432 ;;
872 esac 1433 esac
873 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1434 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
874 fi 1435 fi
1436 case ${exe} in
1437 tail) exe="tail -n +${skip} '${src}'";;
1438 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1439 *) die "makeself cant handle exe '${exe}'"
1440 esac
875 1441
876 # we do this because otherwise a failure in gzip will cause 0 bytes to be sent 1442 # lets grab the first few bytes of the file to figure out what kind of archive it is
877 # to tar which will make tar not extract anything and exit with 0 1443 local filetype tmpfile=$(emktemp)
878 local out="`tail +${skip} ${src} | gzip -cd | tar -x --no-same-owner -v -f -`" 1444 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1445 filetype=$(file -b "${tmpfile}") || die
1446 case ${filetype} in
1447 *tar\ archive*)
1448 eval ${exe} | tar --no-same-owner -xf -
1449 ;;
1450 bzip2*)
1451 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1452 ;;
1453 gzip*)
1454 eval ${exe} | tar --no-same-owner -xzf -
1455 ;;
1456 compress*)
1457 eval ${exe} | gunzip | tar --no-same-owner -xf -
1458 ;;
1459 *)
1460 eerror "Unknown filetype \"${filetype}\" ?"
1461 false
1462 ;;
1463 esac
879 [ -z "${out}" ] && die "failure unpacking makeself ${shrtsrc} ('${ver}' +${skip})" 1464 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
880} 1465}
1466
1467# @FUNCTION: check_license
1468# @USAGE: [license]
1469# @DESCRIPTION:
1470# Display a license for user to accept. If no license is
1471# specified, then ${LICENSE} is used.
1472check_license() {
1473 local lic=$1
1474 if [ -z "${lic}" ] ; then
1475 lic="${PORTDIR}/licenses/${LICENSE}"
1476 else
1477 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1478 lic="${PORTDIR}/licenses/${lic}"
1479 elif [ -e "${PWD}/${lic}" ] ; then
1480 lic="${PWD}/${lic}"
1481 elif [ -e "${lic}" ] ; then
1482 lic="${lic}"
1483 fi
1484 fi
1485 local l="`basename ${lic}`"
1486
1487 # here is where we check for the licenses the user already
1488 # accepted ... if we don't find a match, we make the user accept
1489 local alic
1490 eshopts_push -o noglob # so that bash doesn't expand "*"
1491 for alic in ${ACCEPT_LICENSE} ; do
1492 if [[ ${alic} == ${l} ]]; then
1493 eshopts_pop
1494 return 0
1495 fi
1496 done
1497 eshopts_pop
1498 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1499
1500 local licmsg=$(emktemp)
1501 cat <<-EOF > ${licmsg}
1502 **********************************************************
1503 The following license outlines the terms of use of this
1504 package. You MUST accept this license for installation to
1505 continue. When you are done viewing, hit 'q'. If you
1506 CTRL+C out of this, the install will not run!
1507 **********************************************************
1508
1509 EOF
1510 cat ${lic} >> ${licmsg}
1511 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1512 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1513 read alic
1514 case ${alic} in
1515 yes|Yes|y|Y)
1516 return 0
1517 ;;
1518 *)
1519 echo;echo;echo
1520 eerror "You MUST accept the license to continue! Exiting!"
1521 die "Failed to accept license"
1522 ;;
1523 esac
1524}
1525
1526# @FUNCTION: cdrom_get_cds
1527# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1528# @DESCRIPTION:
1529# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1530# the whole 'non-interactive' policy, but damnit I want CD support !
1531#
1532# With these cdrom functions we handle all the user interaction and
1533# standardize everything. All you have to do is call cdrom_get_cds()
1534# and when the function returns, you can assume that the cd has been
1535# found at CDROM_ROOT.
1536#
1537# The function will attempt to locate a cd based upon a file that is on
1538# the cd. The more files you give this function, the more cds
1539# the cdrom functions will handle.
1540#
1541# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1542# etc... If you want to give the cds better names, then just export
1543# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1544# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1545# also use the CDROM_NAME_SET bash array.
1546#
1547# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1548cdrom_get_cds() {
1549 # first we figure out how many cds we're dealing with by
1550 # the # of files they gave us
1551 local cdcnt=0
1552 local f=
1553 for f in "$@" ; do
1554 ((++cdcnt))
1555 export CDROM_CHECK_${cdcnt}="$f"
1556 done
1557 export CDROM_TOTAL_CDS=${cdcnt}
1558 export CDROM_CURRENT_CD=1
1559
1560 # now we see if the user gave use CD_ROOT ...
1561 # if they did, let's just believe them that it's correct
1562 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1563 local var=
1564 cdcnt=0
1565 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1566 ((++cdcnt))
1567 var="CD_ROOT_${cdcnt}"
1568 [[ -z ${!var} ]] && var="CD_ROOT"
1569 if [[ -z ${!var} ]] ; then
1570 eerror "You must either use just the CD_ROOT"
1571 eerror "or specify ALL the CD_ROOT_X variables."
1572 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1573 die "could not locate CD_ROOT_${cdcnt}"
1574 fi
1575 done
1576 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1577 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1578 export CDROM_SET=-1
1579 for f in ${CDROM_CHECK_1//:/ } ; do
1580 ((++CDROM_SET))
1581 [[ -e ${CDROM_ROOT}/${f} ]] && break
1582 done
1583 export CDROM_MATCH=${f}
1584 return
1585 fi
1586
1587 # User didn't help us out so lets make sure they know they can
1588 # simplify the whole process ...
1589 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1590 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1591 echo
1592 einfo "If you do not have the CD, but have the data files"
1593 einfo "mounted somewhere on your filesystem, just export"
1594 einfo "the variable CD_ROOT so that it points to the"
1595 einfo "directory containing the files."
1596 echo
1597 einfo "For example:"
1598 einfo "export CD_ROOT=/mnt/cdrom"
1599 echo
1600 else
1601 if [[ -n ${CDROM_NAME_SET} ]] ; then
1602 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1603 cdcnt=0
1604 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1605 ((++cdcnt))
1606 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1607 done
1608 fi
1609
1610 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1611 cdcnt=0
1612 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1613 ((++cdcnt))
1614 var="CDROM_NAME_${cdcnt}"
1615 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1616 done
1617 echo
1618 einfo "If you do not have the CDs, but have the data files"
1619 einfo "mounted somewhere on your filesystem, just export"
1620 einfo "the following variables so they point to the right place:"
1621 einfon ""
1622 cdcnt=0
1623 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1624 ((++cdcnt))
1625 echo -n " CD_ROOT_${cdcnt}"
1626 done
1627 echo
1628 einfo "Or, if you have all the files in the same place, or"
1629 einfo "you only have one cdrom, you can export CD_ROOT"
1630 einfo "and that place will be used as the same data source"
1631 einfo "for all the CDs."
1632 echo
1633 einfo "For example:"
1634 einfo "export CD_ROOT_1=/mnt/cdrom"
1635 echo
1636 fi
1637
1638 export CDROM_SET=""
1639 export CDROM_CURRENT_CD=0
1640 cdrom_load_next_cd
1641}
1642
1643# @FUNCTION: cdrom_load_next_cd
1644# @DESCRIPTION:
1645# Some packages are so big they come on multiple CDs. When you're done reading
1646# files off a CD and want access to the next one, just call this function.
1647# Again, all the messy details of user interaction are taken care of for you.
1648# Once this returns, just read the variable CDROM_ROOT for the location of the
1649# mounted CD. Note that you can only go forward in the CD list, so make sure
1650# you only call this function when you're done using the current CD.
1651cdrom_load_next_cd() {
1652 local var
1653 ((++CDROM_CURRENT_CD))
1654
1655 unset CDROM_ROOT
1656 var=CD_ROOT_${CDROM_CURRENT_CD}
1657 [[ -z ${!var} ]] && var="CD_ROOT"
1658 if [[ -z ${!var} ]] ; then
1659 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1660 _cdrom_locate_file_on_cd ${!var}
1661 else
1662 export CDROM_ROOT=${!var}
1663 fi
1664
1665 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1666}
1667
1668# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1669# functions. this should *never* be called from an ebuild.
1670# all it does is try to locate a give file on a cd ... if the cd isn't
1671# found, then a message asking for the user to insert the cdrom will be
1672# displayed and we'll hang out here until:
1673# (1) the file is found on a mounted cdrom
1674# (2) the user hits CTRL+C
1675_cdrom_locate_file_on_cd() {
1676 local mline=""
1677 local showedmsg=0 showjolietmsg=0
1678
1679 while [[ -z ${CDROM_ROOT} ]] ; do
1680 local i=0
1681 local -a cdset=(${*//:/ })
1682 if [[ -n ${CDROM_SET} ]] ; then
1683 cdset=(${cdset[${CDROM_SET}]})
1684 fi
1685
1686 while [[ -n ${cdset[${i}]} ]] ; do
1687 local dir=$(dirname ${cdset[${i}]})
1688 local file=$(basename ${cdset[${i}]})
1689
1690 local point= node= fs= foo=
1691 while read point node fs foo ; do
1692 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1693 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1694 && continue
1695 point=${point//\040/ }
1696 [[ ! -d ${point}/${dir} ]] && continue
1697 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1698 export CDROM_ROOT=${point}
1699 export CDROM_SET=${i}
1700 export CDROM_MATCH=${cdset[${i}]}
1701 return
1702 done <<< "$(get_mounts)"
1703
1704 ((++i))
1705 done
1706
1707 echo
1708 if [[ ${showedmsg} -eq 0 ]] ; then
1709 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1710 if [[ -z ${CDROM_NAME} ]] ; then
1711 einfo "Please insert+mount the cdrom for ${PN} now !"
1712 else
1713 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1714 fi
1715 else
1716 if [[ -z ${CDROM_NAME_1} ]] ; then
1717 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1718 else
1719 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1720 einfo "Please insert+mount the ${!var} cdrom now !"
1721 fi
1722 fi
1723 showedmsg=1
1724 fi
1725 einfo "Press return to scan for the cd again"
1726 einfo "or hit CTRL+C to abort the emerge."
1727 echo
1728 if [[ ${showjolietmsg} -eq 0 ]] ; then
1729 showjolietmsg=1
1730 else
1731 ewarn "If you are having trouble with the detection"
1732 ewarn "of your CD, it is possible that you do not have"
1733 ewarn "Joliet support enabled in your kernel. Please"
1734 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1735 ebeep 5
1736 fi
1737 read || die "something is screwed with your system"
1738 done
1739}
1740
1741# @FUNCTION: strip-linguas
1742# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1743# @DESCRIPTION:
1744# Make sure that LINGUAS only contains languages that
1745# a package can support. The first form allows you to
1746# specify a list of LINGUAS. The -i builds a list of po
1747# files found in all the directories and uses the
1748# intersection of the lists. The -u builds a list of po
1749# files found in all the directories and uses the union
1750# of the lists.
1751strip-linguas() {
1752 local ls newls nols
1753 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1754 local op=$1; shift
1755 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1756 local d f
1757 for d in "$@" ; do
1758 if [[ ${op} == "-u" ]] ; then
1759 newls=${ls}
1760 else
1761 newls=""
1762 fi
1763 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1764 if [[ ${op} == "-i" ]] ; then
1765 has ${f} ${ls} && newls="${newls} ${f}"
1766 else
1767 has ${f} ${ls} || newls="${newls} ${f}"
1768 fi
1769 done
1770 ls=${newls}
1771 done
1772 else
1773 ls="$@"
1774 fi
1775
1776 nols=""
1777 newls=""
1778 for f in ${LINGUAS} ; do
1779 if has ${f} ${ls} ; then
1780 newls="${newls} ${f}"
1781 else
1782 nols="${nols} ${f}"
1783 fi
1784 done
1785 [[ -n ${nols} ]] \
1786 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1787 export LINGUAS=${newls:1}
1788}
1789
1790# @FUNCTION: preserve_old_lib
1791# @USAGE: <libs to preserve> [more libs]
1792# @DESCRIPTION:
1793# These functions are useful when a lib in your package changes ABI SONAME.
1794# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1795# would break packages that link against it. Most people get around this
1796# by using the portage SLOT mechanism, but that is not always a relevant
1797# solution, so instead you can call this from pkg_preinst. See also the
1798# preserve_old_lib_notify function.
1799preserve_old_lib() {
1800 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1801 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1802 die "Invalid preserve_old_lib() usage"
1803 fi
1804 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1805
1806 # let portage worry about it
1807 has preserve-libs ${FEATURES} && return 0
1808
1809 local lib dir
1810 for lib in "$@" ; do
1811 [[ -e ${ROOT}/${lib} ]] || continue
1812 dir=${lib%/*}
1813 dodir ${dir} || die "dodir ${dir} failed"
1814 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1815 touch "${D}"/${lib}
1816 done
1817}
1818
1819# @FUNCTION: preserve_old_lib_notify
1820# @USAGE: <libs to notify> [more libs]
1821# @DESCRIPTION:
1822# Spit helpful messages about the libraries preserved by preserve_old_lib.
1823preserve_old_lib_notify() {
1824 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1825 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1826 die "Invalid preserve_old_lib_notify() usage"
1827 fi
1828
1829 # let portage worry about it
1830 has preserve-libs ${FEATURES} && return 0
1831
1832 local lib notice=0
1833 for lib in "$@" ; do
1834 [[ -e ${ROOT}/${lib} ]] || continue
1835 if [[ ${notice} -eq 0 ]] ; then
1836 notice=1
1837 ewarn "Old versions of installed libraries were detected on your system."
1838 ewarn "In order to avoid breaking packages that depend on these old libs,"
1839 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1840 ewarn "in order to remove these old dependencies. If you do not have this"
1841 ewarn "helper program, simply emerge the 'gentoolkit' package."
1842 ewarn
1843 fi
1844 # temp hack for #348634 #357225
1845 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1846 ewarn " # revdep-rebuild --library '${lib}'"
1847 done
1848 if [[ ${notice} -eq 1 ]] ; then
1849 ewarn
1850 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1851 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1852 for lib in "$@" ; do
1853 ewarn " # rm '${lib}'"
1854 done
1855 fi
1856}
1857
1858# @FUNCTION: built_with_use
1859# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1860# @DESCRIPTION:
1861#
1862# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1863#
1864# A temporary hack until portage properly supports DEPENDing on USE
1865# flags being enabled in packages. This will check to see if the specified
1866# DEPEND atom was built with the specified list of USE flags. The
1867# --missing option controls the behavior if called on a package that does
1868# not actually support the defined USE flags (aka listed in IUSE).
1869# The default is to abort (call die). The -a and -o flags control
1870# the requirements of the USE flags. They correspond to "and" and "or"
1871# logic. So the -a flag means all listed USE flags must be enabled
1872# while the -o flag means at least one of the listed IUSE flags must be
1873# enabled. The --hidden option is really for internal use only as it
1874# means the USE flag we're checking is hidden expanded, so it won't be found
1875# in IUSE like normal USE flags.
1876#
1877# Remember that this function isn't terribly intelligent so order of optional
1878# flags matter.
1879built_with_use() {
1880 local hidden="no"
1881 if [[ $1 == "--hidden" ]] ; then
1882 hidden="yes"
1883 shift
1884 fi
1885
1886 local missing_action="die"
1887 if [[ $1 == "--missing" ]] ; then
1888 missing_action=$2
1889 shift ; shift
1890 case ${missing_action} in
1891 true|false|die) ;;
1892 *) die "unknown action '${missing_action}'";;
1893 esac
1894 fi
1895
1896 local opt=$1
1897 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1898
1899 local PKG=$(best_version $1)
1900 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1901 shift
1902
1903 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1904 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1905
1906 # if the IUSE file doesn't exist, the read will error out, we need to handle
1907 # this gracefully
1908 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1909 case ${missing_action} in
1910 true) return 0;;
1911 false) return 1;;
1912 die) die "Unable to determine what USE flags $PKG was built with";;
1913 esac
1914 fi
1915
1916 if [[ ${hidden} == "no" ]] ; then
1917 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1918 # Don't check USE_EXPAND #147237
1919 local expand
1920 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1921 if [[ $1 == ${expand}_* ]] ; then
1922 expand=""
1923 break
1924 fi
1925 done
1926 if [[ -n ${expand} ]] ; then
1927 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1928 case ${missing_action} in
1929 true) return 0;;
1930 false) return 1;;
1931 die) die "$PKG does not actually support the $1 USE flag!";;
1932 esac
1933 fi
1934 fi
1935 fi
1936
1937 local USE_BUILT=$(<${USEFILE})
1938 while [[ $# -gt 0 ]] ; do
1939 if [[ ${opt} = "-o" ]] ; then
1940 has $1 ${USE_BUILT} && return 0
1941 else
1942 has $1 ${USE_BUILT} || return 1
1943 fi
1944 shift
1945 done
1946 [[ ${opt} = "-a" ]]
1947}
1948
1949# @FUNCTION: epunt_cxx
1950# @USAGE: [dir to scan]
1951# @DESCRIPTION:
1952# Many configure scripts wrongly bail when a C++ compiler could not be
1953# detected. If dir is not specified, then it defaults to ${S}.
1954#
1955# http://bugs.gentoo.org/73450
1956epunt_cxx() {
1957 local dir=$1
1958 [[ -z ${dir} ]] && dir=${S}
1959 ebegin "Removing useless C++ checks"
1960 local f
1961 find "${dir}" -name configure | while read f ; do
1962 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1963 done
1964 eend 0
1965}
1966
1967# @FUNCTION: make_wrapper
1968# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1969# @DESCRIPTION:
1970# Create a shell wrapper script named wrapper in installpath
1971# (defaults to the bindir) to execute target (default of wrapper) by
1972# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1973# libpaths followed by optionally changing directory to chdir.
1974make_wrapper() {
1975 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1976 local tmpwrapper=$(emktemp)
1977 # We don't want to quote ${bin} so that people can pass complex
1978 # things as $bin ... "./someprog --args"
1979 cat << EOF > "${tmpwrapper}"
1980#!/bin/sh
1981cd "${chdir:-.}"
1982if [ -n "${libdir}" ] ; then
1983 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1984 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1985 else
1986 export LD_LIBRARY_PATH="${libdir}"
1987 fi
1988fi
1989exec ${bin} "\$@"
1990EOF
1991 chmod go+rx "${tmpwrapper}"
1992 if [[ -n ${path} ]] ; then
1993 (
1994 exeinto "${path}"
1995 newexe "${tmpwrapper}" "${wrapper}"
1996 ) || die
1997 else
1998 newbin "${tmpwrapper}" "${wrapper}" || die
1999 fi
2000}
2001
2002# @FUNCTION: path_exists
2003# @USAGE: [-a|-o] <paths>
2004# @DESCRIPTION:
2005# Check if the specified paths exist. Works for all types of paths
2006# (files/dirs/etc...). The -a and -o flags control the requirements
2007# of the paths. They correspond to "and" and "or" logic. So the -a
2008# flag means all the paths must exist while the -o flag means at least
2009# one of the paths must exist. The default behavior is "and". If no
2010# paths are specified, then the return value is "false".
2011path_exists() {
2012 local opt=$1
2013 [[ ${opt} == -[ao] ]] && shift || opt="-a"
2014
2015 # no paths -> return false
2016 # same behavior as: [[ -e "" ]]
2017 [[ $# -eq 0 ]] && return 1
2018
2019 local p r=0
2020 for p in "$@" ; do
2021 [[ -e ${p} ]]
2022 : $(( r += $? ))
2023 done
2024
2025 case ${opt} in
2026 -a) return $(( r != 0 )) ;;
2027 -o) return $(( r == $# )) ;;
2028 esac
2029}

Legend:
Removed from v.1.41  
changed lines
  Added in v.1.362

  ViewVC Help
Powered by ViewVC 1.1.20